/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified for GIF 1998 Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"gifslice.h"

extern picsliceinfo	psi;

extern int	loadGIFfile( picsliceinfo* );
extern int	drawGIF( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	psierr( char*, int );

GVIEW *
GV_Load_Gif( fname )
char	*fname;
{
	char	format[]= "GIF";
	GVIEW	*gp;
	int	ret;

	if( (psi.fn= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( ( ret= loadGIFfile( &psi ) ) != PICSLICE_NORMAL ){
		psierr( format, ret );
		return	NULL;
	}
	if( !(gp= GV_Alloc( psi.Width, psi.Height, psi.color,
					fname, NULL, 0 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawGIF( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}else {
		unsigned short	*str= gp->palet,
				*ptr= psi.ColorMap;
		int	i;
		for( i= 0 ; i< psi.BitPixel ; i++ ){
			*str++= *ptr++;
		}
	}
	return gp;
}
