/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified 1998 by Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"pislice.h"

extern unsigned char	com[256];
extern picsliceinfo	psi;
extern int	loadPifile( picsliceinfo*, unsigned char* );
extern int	drawPi( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	psierr( char*, int );



GVIEW *
GV_Load_Pi( fname )
char	*fname;
{
	char	format[]= "Pi";
	GVIEW	*gp;
	int	ret;

	if( (psi.filehandle= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( ( ret= loadPifile( &psi, com ) ) != PICSLICE_NORMAL ){
		psierr( format, ret );
		return NULL;
	}
	if( !(gp= GV_Alloc( psi.width, psi.height, psi.PiPlaneSize,
					fname, com+2, psi.width*2+64 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawPi( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}else {
		unsigned short	*str= gp->palet,
				*ptr= psi.palet;
		int	i;
		for( i= 0 ; i< psi.MaxColorGuaranteed ; i++ ){
			*str++= *ptr++;
		}
	}
	return	gp;
}
